Leetcode刷题详解——长度最小的子数组

1. 题目链接:209. 长度最小的子数组

2. 题目描述:

给定一个含有 n 个正整数的数组和一个正整数 target 。

找出该数组中满足其总和大于等于 target 的长度最小的 连续子数组 [numsl, numsl+1, ..., numsr-1, numsr] ,并返回其长度**。**如果不存在符合条件的子数组,返回 0 。

示例 1:

复制代码
输入:target = 7, nums = [2,3,1,2,4,3]
输出:2
解释:子数组 [4,3] 是该条件下的长度最小的子数组。

示例 2:

复制代码
输入:target = 4, nums = [1,4,4]
输出:1

示例 3:

复制代码
输入:target = 11, nums = [1,1,1,1,1,1,1,1]
输出:0

提示:

  • 1 <= target <= 109
  • 1 <= nums.length <= 105
  • 1 <= nums[i] <= 105

3.解法(滑动窗口)

3.1算法思路

由于此问题分析的对象是「⼀段连续的区间」,因此可以考虑「滑动窗⼝」的思想来解决这道题。

让滑动窗⼝满⾜:从 i 位置开始,窗⼝内所有元素的和⼩于 target (那么当窗⼝内元素之和第⼀次⼤于等于⽬标值的时候,就是 i 位置开始,满⾜条件的最⼩⻓度)。

做法:将右端元素划⼊窗⼝中,统计出此时窗⼝内元素的和:

1.如果窗⼝内元素之和⼤于等于 target :更新结果,并且将左端元素划出去的同时继续判

断是否满⾜条件并更新结果(因为左端元素可能很⼩,划出去之后依旧满⾜条件)

2.如果窗⼝内元素之和不满⾜条件: right++ ,另下⼀个元素进⼊窗⼝。

3.2C++算法代码

c++ 复制代码
class Solution {
public:
    int minSubArrayLen(int target, vector<int>& nums) {
        int n=nums.size();
        int left=0;
        int right=0;
        int len=INT_MAX;
        int sum=0;
        for(left=0,right=0;right<n;right++)
        {
            sum+=nums[right];//进窗口
            while(sum>=target)//判断
            {
                len=min(len,right-left+1);//更新结果
                sum-=nums[left++];//出窗口
            }
        }
        return len==INT_MAX?0:len;
    }
};
相关推荐
罗湖老棍子1 小时前
Biorhythms(信息学奥赛一本通- P1639)
算法·数论·裴蜀定理·扩展欧几里得·扩展中国剩余定理
奋发向前wcx6 小时前
CSP-J复赛模拟赛4 王晨旭补题 2026.10.5
算法
念何架构之路9 小时前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
晒太羊的猫10 小时前
hot100动态规划刷题
算法·动态规划
weixin_5310946910 小时前
heap_4内存管理
java·开发语言·算法
余额瞒着我当琳10 小时前
红黑树的实现--红黑树的概念、规则、效率、结构、旋转、查找、验证
数据结构·c++·算法
程序员南飞10 小时前
win系统安装minio
java·数据结构·算法
青少儿编程课堂10 小时前
AC自动机多模式串匹配精讲:校园关键词巡检实战解析
c++·python·算法·bfs·信息学竞赛
longlongzihan11 小时前
LeetCode 5. 最长回文子串:从暴力匹配到中心扩展的思维演进
c++·算法·leetcode
waoooqwe11 小时前
问卷样本真实吗
大数据·数据库·算法·数据分析